clear;clc;
addpath('..')

tic;

n1 = 50; n2 = 50; n3 = 50; nn = [n1 n2 n3];
n = n1+n2+n3;
N = 2*(n1 + n2) + n3; M = 100; nsim = 400;
sM = linspace(0, 1, M);

beta = [beta1(sM); beta2(sM); beta3(sM)];

eta11 = eta1(sM); eta21 = eta2(sM);
eta31 = eta21; eta41 = eta11;

lambda = 0.05*[[1 0.5] [1 0.5]];

SigmaA = lambda(1)*(eta11')*eta11 + lambda(2)*(eta21')*eta21;
SigmaC = lambda(3)*(eta31')*eta31 + lambda(4)*(eta41')*eta41;
SigmaC = mean(diag(SigmaC))*eye(M); % const or non-const

SigmaEG = zeros(M,M);
SigmaEL = 0.05;

log_WsigmaA = zeros(3, M, nsim); log_WsigmaN = zeros(2, M, nsim);

h = 0.08/n^(1/3);

% mypool = parpool(4);

parfor kk = 1:nsim
    
    rng(kk*1234567);
    
    [y, X, famid, zygosity] = ...
        FSEM_gendata(beta, SigmaA, SigmaC, SigmaEG, SigmaEL, nn);
%     % mle estimation
%     [paramsA(:,:,kk), paramsN(:,:,kk)] = ...
%         FSEM_mle(y, X, famid, zygosity);
%     % wmle estimation
    [log_WsigmaA(:,:,kk), log_WsigmaN(:,:,kk), ~, ~] = ...
        FSEM_wmle(y, X, famid, zygosity, sM, h);
% %     % wlrt pointwise test
% %     [WLRT_vec(kk,:), Wp_vec(kk,:)] = ...
% %         FSEM_wlrt(log_WsigmaA(:,:,kk), log_WsigmaN(:,:,kk), R, famid, ...
% %                   zygosity, sM, h); 
%     % covariance structure estimation
%     ob = FSEM_cov_ob(R, famid, zygosity, sM);
%     [SigmaA_est(:,:,kk), SigmaC_est(:,:,kk), SigmaE_est(:,:,kk)] = ...
%         FSEM_cov(R, famid, zygosity, sM, ob);
end

delete(mypool);

tt = toc/60;

save est_n50_c1_const.mat
