clear; clc;
addpath('..')
addpath('../src')
addpath('../src/extra')
addpath('../yw')
addpath('../ywest')

tic;

n1 = 50; n2 = 50; n3 = 50; nn = [n1 n2 n3];
n = n1+n2+n3;
N = 2*(n1 + n2) + n3; M = 100; nsim = 400;
sM = linspace(0, 1, M);

beta = [beta1(sM); beta2(sM); beta3(sM)];

eta11 = eta1(sM); eta21 = eta2(sM);
eta31 = eta21; eta41 = eta11;

lambda = 0.05*[[1 0.5] [1 0.5]];

SigmaA = lambda(1)*(eta11')*eta11 + lambda(2)*(eta21')*eta21;
SigmaC = lambda(3)*(eta31')*eta31 + lambda(4)*(eta41')*eta41;
SigmaC = mean(diag(SigmaC))*eye(M);

SigmaEG = zeros(M, M);
SigmaEL = 0.05;

herits = zeros(nsim, M);

mypool = parpool(4);

parfor kk = 1:nsim
    
    rng(kk*1234567);
    
    [y, X, famid, zygosity] = ...
        FSEM_gendata(beta, SigmaA, SigmaC, SigmaEG, SigmaEL, nn);
    
    paramsA = FSEM_mle(y, X, famid, zygosity);
    betaA = paramsA(4:end,:);
    R = y - X*betaA;
    
    herits(kk,:) = YW_h(R, famid, zygosity);
end

delete(mypool);

tt = toc/60;

save est_n50_c1_yw_const.mat