clear; clc;
load('est_n100_c2.mat')
beta_est = paramsA(4:6,:,:);
beta_mse = squeeze(mean(mean((beta_est - repmat(beta,[1,1,nsim])).^2)));

sigma0  = [diag(SigmaA)'; diag(SigmaC)'; repmat(SigmaE,1,size(SigmaA,1))];
WsigmaA = exp(log_WsigmaA);
sigmaA  = exp(paramsA(1:3,:,:));
Wsigma_mse  = squeeze(mean((WsigmaA-repmat(sigma0,1,1,nsim)).^2,2));
sigma_mse   = squeeze(mean((sigmaA-repmat(sigma0,1,1,nsim)).^2,2));
SigmaA_mse = squeeze(mean(mean((SigmaA_est-repmat(SigmaA,[1,1,nsim])).^2)));
SigmaC_mse = squeeze(mean(mean((SigmaC_est-repmat(SigmaC,[1,1,nsim])).^2)));
SigmaE_mse = squeeze(mean(mean(SigmaE_est.^2)));

all_mse = [beta_mse, Wsigma_mse', sigma_mse', SigmaA_mse, SigmaC_mse, SigmaE_mse];

box=boxplot(all_mse, 'Labels', {'$\widehat{\beta}$',...
'$\widehat{\sigma}_{a,K}^2$',...
'$\widehat{\sigma}_{c,K}^2$',...
'$\widehat{\sigma}_{e,K}^2$',...
'$\widehat{\sigma}_{a}^2$',...
'$\widehat{\sigma}_{c}^2$',...
'$\widehat{\sigma}_{e}^2$',...
'$\widehat{\Sigma}_a$',...
'$\widehat{\Sigma}_c$', ...
'$\widehat{\Sigma}_{e,G}$'});
set(gca,'TickLabelInterpreter','latex','fontsize', 15);
ylabel('MSE','FontSize',15)

