load('est_n100_c2.mat')

M = size(SigmaA, 1);

beta_est = paramsA(4:6,:,:);
SigmaA_est_m = mean(SigmaA_est,3);
SigmaC_est_m = mean(SigmaC_est,3); 
SigmaE_est_m = mean(SigmaE_est,3);

beta_est_m = mean(beta_est,3); 
beta_est_se = std(beta_est,0,3); 

beta_est_u = beta_est_m + 2*beta_est_se;
beta_est_l = beta_est_m - 2*beta_est_se;

lb = min(min(SigmaA(:)), min(SigmaC(:))); ub = max(max(SigmaA(:)), max(SigmaC(:))); 
xx = linspace(1, size(beta,2), size(beta,2)); 
figure; 
ax1 = subplot(2,4,1); 
plot(xx, beta(1,:),'r', xx, beta(2,:),'g', xx, beta(3,:),'b');
xlabel('arclength(a)', 'Fontsize', 10);
title('$\beta$','Interpreter','latex', 'Fontsize', 20);
subplot(2,4,2); 
imagesc(SigmaA, [lb,ub]); colorbar; 
title('$\Sigma_a$','Interpreter','latex','Fontsize', 20);
xlabel('(b)', 'Fontsize', 10);
subplot(2,4,3); 
imagesc(SigmaC, [lb,ub]); colorbar;
title('$\Sigma_c$','Interpreter','latex','Fontsize', 20);
xlabel('(c)', 'Fontsize', 10);
subplot(2,4,4);
imagesc(zeros(M,M),[lb,ub]); colorbar;
title('$\Sigma_{e,G}$','Interpreter','latex','Fontsize', 20);
xlabel('(d)', 'Fontsize', 10);
ax4 = subplot(2,4,5);
plot(xx, beta_est_m(1,:),'r', xx, beta_est_u(1,:),'--r', xx, beta_est_l(1,:), '--r');
hold on; plot(xx, beta_est_m(2,:),'g', xx, beta_est_u(2,:),'--g', xx, beta_est_l(2,:), '--g'); 
hold on; plot(xx, beta_est_m(3,:),'b', xx, beta_est_u(3,:),'--b', xx, beta_est_l(3,:), '--b');
xlabel('arclength(e)', 'Fontsize', 10);
title('$\widehat{\beta}$','Interpreter','latex','Fontsize', 20);
subplot(2,4,6); 
imagesc(SigmaA_est_m, [lb,ub]); colorbar;
title('$\widehat{\Sigma}_a$','Interpreter','latex','Fontsize', 20);
xlabel('(f)', 'Fontsize', 10);
subplot(2,4,7);
imagesc(SigmaC_est_m, [lb,ub]); colorbar;
title('$\widehat{\Sigma}_c$','Interpreter','latex','Fontsize', 20);
xlabel('(g)', 'Fontsize', 10);
subplot(2,4,8);
imagesc(SigmaE_est_m, [lb,ub]); colorbar;
title('$\widehat{\Sigma}_{e,G}$','Interpreter','latex','Fontsize', 20);
xlabel('(h)', 'Fontsize', 10);
axis([ax1,ax4], [0 100 -0.75 1.5]);

