clear; clc;
addpath('..')
addpath('../src')

tic;

n1 = 100; n2 = 100; n3 = 100; nn = [n1 n2 n3];
n = n1+n2+n3;
N = 2*(n1 + n2) + n3; M = 100; nsim = 400;
sM = linspace(0, 1, M);

beta = [beta1(sM); beta2(sM); beta3(sM)];

eta11 = eta1(sM); eta21 = eta2(sM);
eta31 = eta21; eta41 = eta11;

cvec = [0, 0.01, 0.02, 0.03, 0.04];
ii = 5;
lambda = [cvec(ii)*[1 0.5] 0.0*[1 0.5]];

SigmaA = lambda(1)*(eta11')*eta11 + lambda(2)*(eta21')*eta21;
SigmaC = lambda(3)*(eta31')*eta31 + lambda(4)*(eta41')*eta41;

SigmaEG = zeros(M, M);
SigmaEL = 2;

global_a = zeros(nsim, 1);

% mypool = parpool(4);

h = 0.01;
% h = 0.08/n^(1/3);
parfor kk = 1:nsim
    
    if mod(kk, 50) == 0
        kk
    end
    
    rng(kk*1234567);
    
    [y, X, famid, zygosity] = ...
        FSEM_gendata(beta, SigmaA, SigmaC, SigmaEG, SigmaEL, nn);
    paramsA = FSEM_mle(y, X, famid, zygosity);
    betaA = paramsA(4:end,:);
    R = y - X*betaA;
    
    global_a(kk) = FSEM_global_test(R, famid, zygosity);
end

% delete(mypool);

tt = toc/60;

filename = strcat('test_n', num2str(n), '_ii', num2str(ii), '_sigmael_', num2str(SigmaEL), '.mat'); 

save(filename)