global_test_power_n150_e1 = zeros(5,2);
global_test_power_n150_e2 = zeros(5,2);
global_test_power_n300_e1 = zeros(5,2);
global_test_power_n300_e2 = zeros(5,2);

for kk = 1:5
    filename = strcat('test_n150_ii', num2str(kk), '_sigmael_1.mat');
    load(filename);
    global_test_power_n150_e1(kk,1) = mean(global_a < 0.01);
    global_test_power_n150_e1(kk,2) = mean(global_a < 0.05);
    filename = strcat('test_n150_ii', num2str(kk), '_sigmael_2.mat');
    load(filename);
    global_test_power_n150_e2(kk,1) = mean(global_a < 0.01);
    global_test_power_n150_e2(kk,2) = mean(global_a < 0.05); 
    
    filename = strcat('test_n300_ii', num2str(kk), '_sigmael_1.mat');
    load(filename);
    global_test_power_n300_e1(kk,1) = mean(global_a < 0.01);
    global_test_power_n300_e1(kk,2) = mean(global_a < 0.05);
    filename = strcat('test_n300_ii', num2str(kk), '_sigmael_2.mat');
    load(filename);
    global_test_power_n300_e2(kk,1) = mean(global_a < 0.01);
    global_test_power_n300_e2(kk,2) = mean(global_a < 0.05);    
end

xx = 0.01*linspace(0,4,5);

figure;
ax1 = subplot(1,2,1);
plot(xx, global_test_power_n150_e1(:,1),'rx--');hold on; 
plot(xx, global_test_power_n150_e1(:,2),'rx-');hold on;
plot(xx, global_test_power_n150_e2(:,1),'bx--');hold on;
plot(xx, global_test_power_n150_e2(:,2),'bx-');
title('n = 150','FontSize',20); 
xlabel('c', 'FontSize', 20);
ylabel('power', 'FontSize', 20);
ll = legend('T_n, \alpha=0.01, \Sigma_e = 1','T_n, \alpha=0.05, \Sigma_e = 1', ...
    'T_n, \alpha=0.01, \Sigma_e = 2','T_n, \alpha=0.05, \Sigma_e = 2', ...
'Location', 'NorthWest');
set(ll, 'FontSize', 20)

ax2 = subplot(1,2,2);
plot(xx, global_test_power_n300_e1(:,1),'rx--');hold on; 
plot(xx, global_test_power_n300_e1(:,2),'rx-');hold on;
plot(xx, global_test_power_n300_e2(:,1),'bx--');hold on;
plot(xx, global_test_power_n300_e2(:,2),'bx-');
title('n = 300','FontSize',20); 
xlabel('c', 'FontSize', 20);
ylabel('power', 'FontSize', 20);
ll = legend('T_n, \alpha=0.01, \Sigma_e = 1','T_n, \alpha=0.05, \Sigma_e = 1', ...
    'T_n, \alpha=0.01, \Sigma_e = 2','T_n, \alpha=0.05, \Sigma_e = 2', ...
'Location', 'NorthWest');
set(ll, 'FontSize', 20)

linkaxes([ax2, ax1], 'xy')