addpath('..')
load('demo.mat');

FA = csvread('FA_GENU.csv', 1, 1)';
FA(end,:) = [];
FA(:, any(isnan(FA), 1)) = []; % remove all columns with NaN

[MZtp1, MZtp2, DZtp1, DZtp2, ~] = FSEM_index(famid, zygosity);

MD = csvread('MD_GENU.csv', 1, 1)';
MD(end,:) = [];
MD(:, any(isnan(MD), 1)) = []; % remove all columns with NaN

rng(123)
ind = randsample(1:length(famid), 40); 
ind1 = randsample(famid(MZtp1), 2); 
ind2 = randsample(famid(DZtp1), 2);
subplot(2,2,1); 
plot(FA(ind,:)'); 
title('FA'); 
xlabel('arclength-(a)', 'FontSize',10);
ylabel('FA','FontSize',10);

subplot(2,2,2); 
plot(MD(ind,:)'); 
title('MD');
xlabel('arclength-(b)','FontSize',10);
ylabel('MD','FontSize',10);

subplot(2,2,3); 
plot(FA(famid==ind1(1),:)','r'); 
hold on; 
plot(FA(famid==ind1(2),:)','g'); 
title('MZ twin pair'); 
xlabel('arclength-(c)','FontSize',10);
ylabel('FA','FontSize',10);

subplot(2,2,4); 
plot(FA(famid==ind2(1),:)','r'); 
hold on; 
plot(FA(famid==ind2(2),:)','g'); 
title('DZ twin pair'); 
xlabel('arclength-(d)','FontSize',10);
ylabel('FA','FontSize',10);


