load('real_data.mat');
addpath('..')
addpath('../src')
eps = 1e-6;
%% fig_real_pval.eps
figure; 
FA_params_LRT = exp(FA_paramsA(1:3,:));
FA_params_WLRT = exp(FA_log_WsigmaA(1:3,:));
FA_herit_YW = YW_h(FA,famid,zygosity);
FA_herit_LRT = FA_params_LRT(1,:)./sum(FA_params_LRT);
FA_herit_WLRT = FA_params_WLRT(1,:)./sum(FA_params_WLRT);

subplot(2,2,1); plot(FA_herit_LRT,'r'); hold on; 
plot(FA_herit_WLRT,'b'); hold on;
plot(FA_herit_YW,'g'); 
legend('LRT','WLRT','YW')
title('FA: Estimated heritability along genu fiber tract','FontSize',14); 
xlabel('arclength-(a)','FontSize',10);
subplot(2,2,3); plot(-log10(max(FA_p_vec,eps)),'r'); hold on; 
plot(-log10(max(FA_Wp_vec,eps)),'b'); 
line([0,100],[-log10(0.05) -log10(0.05)],'Color','k');
legend('LRT','WLRT');
title('FA: -log10(p) values along genu fiber tract','FontSize',14); 
xlabel('arclength-(c)','FontSize',10);

MD_params_LRT = exp(MD_paramsA(1:3,:));
MD_params_WLRT = exp(MD_log_WsigmaA(1:3,:));
MD_herit_YW = YW_h(MD,famid,zygosity);
MD_herit_LRT = MD_params_LRT(1,:)./sum(MD_params_LRT);
MD_herit_WLRT = MD_params_WLRT(1,:)./sum(MD_params_WLRT);

subplot(2,2,2); plot(MD_herit_LRT,'r'); hold on; 
plot(MD_herit_WLRT,'b'); hold on;
plot(MD_herit_YW,'g'); 
legend('LRT','WLRT','YW')

title('MD: Estimated heritability along genu fiber tract','FontSize',14); 
xlabel('arclength-(b)','FontSize',10);
subplot(2,2,4); plot(-log10(max(eps,MD_p_vec)),'r'); hold on; 
plot(-log10(max(eps,MD_Wp_vec)),'b'); 
line([0,100],[-log10(0.05) -log10(0.05)],'Color','k');
legend('LRT','WLRT');
title('MD: -log10(p) values along genu fiber tract','FontSize',14); 
xlabel('arclength-(d)','FontSize',10);

%% fig_real_coef_cb.eps
figure; 
subplot(2,3,1); plot(FA_paramsA(4,:),'b'); xlabel('arclength-(a)','FontSize',10);
ylabel('95% confidence band', 'FontSize', 10);
hold on; plot(FA_paramsA(4,:)+1.96*FA_paramsA_se(4,:),'--r'); 
         plot(FA_paramsA(4,:)-1.96*FA_paramsA_se(4,:),'--r');
         title('FA: intercept','FontSize',14);
subplot(2,3,2); plot(FA_paramsA(5,:)); xlabel('arclength-(b)','FontSize',10);
ylabel('95% confidence band', 'FontSize', 10);
hold on; plot(FA_paramsA(5,:)+1.96*FA_paramsA_se(5,:),'--r'); 
         plot(FA_paramsA(5,:)-1.96*FA_paramsA_se(5,:),'--r');
         title('FA: gender','FontSize',14);
subplot(2,3,3); plot(FA_paramsA(6,:)); xlabel('arclength-(c)','FontSize',10);
ylabel('95% confidence band', 'FontSize', 10);
hold on; plot(FA_paramsA(6,:)+1.96*FA_paramsA_se(6,:),'--r'); 
         plot(FA_paramsA(6,:)-1.96*FA_paramsA_se(6,:),'--r');
         title('FA: age','FontSize',14);
subplot(2,3,4); plot(MD_paramsA(4,:)); xlabel('arclength-(d)','FontSize',10);
ylabel('95% confidence band', 'FontSize', 10);
hold on; plot(MD_paramsA(4,:)+1.96*MD_paramsA_se(4,:),'--r'); 
         plot(MD_paramsA(4,:)-1.96*MD_paramsA_se(4,:),'--r');
         title('MD: intercept','FontSize',14);
subplot(2,3,5); plot(MD_paramsA(5,:)); xlabel('arclength-(e)','FontSize',10);
ylabel('95% confidence band', 'FontSize', 10);
hold on; plot(MD_paramsA(5,:)+1.96*MD_paramsA_se(5,:),'--r'); 
         plot(MD_paramsA(5,:)-1.96*MD_paramsA_se(5,:),'--r');
         title('MD: gender','FontSize',14);
subplot(2,3,6); plot(MD_paramsA(6,:)); xlabel('arclength-(f)','FontSize',10);
ylabel('95% confidence band', 'FontSize', 10);
hold on; plot(MD_paramsA(6,:)+1.96*MD_paramsA_se(6,:),'--r'); 
         plot(MD_paramsA(6,:)-1.96*MD_paramsA_se(6,:),'--r');
         title('MD: age','FontSize',14);
         
%% fig_real_cov.eps 

FA_lb = min([min(FA_SigmaA_est(:)), min(FA_SigmaC_est(:)), min(FA_SigmaE_est(:))]); 
FA_ub = max([max(FA_SigmaA_est(:)), max(FA_SigmaC_est(:)), max(FA_SigmaE_est(:))]); 
MD_lb = min([min(MD_SigmaA_est(:)), min(MD_SigmaC_est(:)), min(MD_SigmaE_est(:))]); 
MD_ub = max([max(MD_SigmaA_est(:)), max(MD_SigmaC_est(:)), max(MD_SigmaE_est(:))]); 

figure; 
subplot(2,3,1); imagesc(FA_SigmaA_est, [FA_lb, FA_ub]); 
colorbar; title('FA: Estimated Genetic Covariance','FontSize',10);
xlabel('(a)','FontSize',10);
subplot(2,3,2); imagesc(FA_SigmaC_est, [FA_lb, FA_ub]); 
colorbar; title('FA: Estimated Common Environmental Covariance','FontSize',10);
xlabel('(b)','FontSize',10);
subplot(2,3,3); imagesc(FA_SigmaE_est, [FA_lb, FA_ub]);
colorbar; title('FA: Estimated Unique Environmental Covariance','FontSize',10);
xlabel('(c)','FontSize',10);

subplot(2,3,4); imagesc(MD_SigmaA_est, [MD_lb, MD_ub]); 
colorbar; title('MD: Estimated Genetic Covariance','FontSize',10);
xlabel('(d)','FontSize',10);
subplot(2,3,5); imagesc(MD_SigmaC_est, [MD_lb, MD_ub]); 
colorbar; title('MD: Estimated Common Environmental Covariance','FontSize',10);
xlabel('(e)','FontSize',10);
subplot(2,3,6); imagesc(MD_SigmaE_est, [MD_lb, MD_ub]);
colorbar; title('MD: Estimated Unique Environmental Covariance','FontSize',10);
xlabel('(f)','FontSize',10);

%% done
% FA_SigmaA_est = pd(FA_SigmaA_est);
% FA_SigmaC_est = pd(FA_SigmaC_est);
% MD_SigmaA_est = pd(MD_SigmaA_est);
% MD_SigmaC_est = pd(MD_SigmaC_est);
% 
% dd = diag(1./sqrt(diag(FA_SigmaA_est)));
% FA_corrA_est = dd*FA_SigmaA_est*dd;
% dd = diag(1./sqrt(diag(FA_SigmaC_est)));
% FA_corrC_est = dd*FA_SigmaC_est*dd;
% dd = diag(1./sqrt(diag(MD_SigmaA_est)));
% MD_corrA_est = dd*MD_SigmaA_est*dd;
% dd = diag(1./sqrt(diag(MD_SigmaC_est)));
% MD_corrC_est = dd*MD_SigmaC_est*dd;
% 
% figure; 
% subplot(2,2,1); imagesc(FA_corrA_est); 
% colorbar; title('FA: Estimated Genetic Correlation Matrix','FontSize',14);
% xlabel('(a)','FontSize',20);
% subplot(2,2,2); imagesc(FA_corrC_est); 
% colorbar; title('FA: Estimated Common Environmental Correlation Matrix','FontSize',14);
% xlabel('(b)','FontSize',20);
% subplot(2,2,3); imagesc(MD_corrA_est); 
% colorbar; title('MD: Estimated Genetic Correlation Matrix','FontSize',14);
% xlabel('(c)','FontSize',20);
% subplot(2,2,4); imagesc(MD_corrC_est); 
% colorbar; title('MD: Estimated Common Environmental Correlation Matrix','FontSize',14);
% xlabel('(d)','FontSize',20);