function [pval, ts] = FSEM_global_test(R, famid, zygosity)

[MZtp1, MZtp2, DZtp1, DZtp2, ~] = FSEM_index(famid, zygosity);

N = size(R, 1);
M = size(R, 2);

sM = linspace(0,1,M);
knots = [min(sM), quantile_knots(sM,5), max(sM)];

bM = bsplineMat(sM, knots, 4);
pbM = (bM'*bM)\bM';

cM = R*pbM';
MZ = cM(MZtp1,:) - cM(MZtp2,:);
DZ = cM(DZtp1,:) - cM(DZtp2,:);
DZ = DZ'*DZ;
MZ = MZ'*MZ;
D = eig(DZ, MZ);
ts = max(D);

nb = 1000;
tss = zeros(nb,1);

for ii = 1:nb
    cM = R(randperm(N),:)*pbM';
    MZ = cM(MZtp1,:) - cM(MZtp2,:);
    DZ = cM(DZtp1,:) - cM(DZtp2,:);
    DZ = DZ'*DZ;
    MZ = MZ'*MZ;
    D = eig(DZ, MZ);
    tss(ii) = max(D);
end

pval = mean(tss > ts);

end