% FSEM_lrt_a does pointwise test given parameter estimates via LRT

% argin
% paramsA: (3+p) x M matrix
% paramsN: (2+p) x M matrix
% y: N x M matrix
% X: N x p matrix
% famid: N x 1 vector
% zygosity: N x 1 vector

% argout
% LRT_vec: 1 x M vector;
% p_vec: 1 x M vector; p values

% 08/12/2017
% Shikai Luo

function [LRT_vec, p_vec] = FSEM_lrt(paramsA, paramsN, y, X, famid, zygosity)

K = size(paramsA, 2);

LRT_vec = zeros(1, K);

for kk = 1:K
    fa = FSEM_lla(paramsA(:,kk), y(:,kk), X, famid, zygosity);
    fn = FSEM_lln(paramsN(:,kk), y(:,kk), X, famid, zygosity);
    LRT_vec(kk) = 2*max(0, fn-fa);
end

p_vec = 1-normcdf(sqrt(LRT_vec));

end
