function [pval] = YW(y, n1, n2, n3)

N = 2*(n1+n2)+n3; M = size(y, 2);

sM = linspace(0,1,M);
knots = [min(sM), quantile_knots(sM,5), max(sM)];

bM = bsplineMat(sM, knots, 4);
pbM = (bM'*bM)\bM';

cM = y*pbM';
val = BW(cM,n1,n2,n3);

nb = 1000;
vals = zeros(nb,1);
for ii = 1:nb
    cMii = y(randperm(N),:)*pbM';
    vals(ii) = BW(cMii,n1,n2,n3);
end

pval = mean(vals > val);

end